local building, platform, nanopoint = piece "root", piece "plate", piece "nano"
local arms1 = piece "arms1"
local arms2 = piece "arms2"
-- declares all the pieces we'll be using.

function script.Create(unitID)
	Hide(arms1)
	Hide(arms2)
	Move(platform,y_axis,-31)
	Move(nanopoint,y_axis,11)
	StartThread(RunningOutOfEnergy)
	StartThread(Cloak)
	StartThread(DecoyDeath)
    return 0
end

function script.QueryBuildInfo() return nanopoint end
-- When building a unit in this building, put it on the "platform" piece.

function script.QueryNanoPiece() return nanopoint end
-- If using nanospray, make the nanospray appear from the "nanopoint" piece (the sphere). This won't be used here, but meh.

function script.Activate()
    -- Begin building! - open the yard to let vehicles move around in the building, start building, and repel any other units in the way.
	SetUnitValue(COB.YARD_OPEN, 1)
	SetUnitValue(COB.INBUILDSTANCE, 1)
	--SetUnitValue(COB.BUGGER_OFF, 1)
    -- This uses a lua way of setting old COB constants. There's probably a better lua way of doing this directly, but I don't know what it is. This method seems to work fine, though.
	return 1
end


function script.Deactivate()
    -- End building!
	SetUnitValue(COB.YARD_OPEN, 0)
	SetUnitValue(COB.INBUILDSTANCE, 0)
	--SetUnitValue(COB.BUGGER_OFF, 0)
	return 0
end


--Actually, I'm not sure if Activate() is called when the base is finished, rather than when it starts building anything. I'll need to check that.

function script.Killed(recentDamage, maxHealth)
	local x,y,z = Spring.GetUnitBasePosition(unitID)
	Spring.SpawnCEG("BUILDINGLARGEDEATH_FX",x,y,z,0,0,0,5,0)
	return 0
end

function RunningOutOfEnergy()
	while true do
		energy = Spring.GetTeamResources(Spring.GetUnitTeam(unitID),"energy")
	
		if energy < 80 then
			Spring.SetUnitBuildSpeed(unitID,energy)
		else
			Spring.SetUnitBuildSpeed(unitID,80)
		end
		Sleep(1000)
	end
end

function Cloak()
	while true do
		if Spring.GetUnitIsCloaked(unitID) then
			childID = Spring.GetUnitIsBuilding(unitID)
			if (childID) then
				if Spring.ValidUnitID(childID) then
					env = Spring.UnitScript.GetScriptEnv(childID)
					if env then 
						env.hidden = true
					end
					--Spring.UnitScript.CallAsUnit(childID, Spring.UnitScript.HideThings,nil)
					--Spring.CallCobScript(childID, "HideThings")
					--Spring.SetUnitCloak(childID,Spring.GetUnitIsCloaked(unitID))
				end
			end
		end
		Sleep(100)
	end
end

function DecoyDeath()
	while true do
		energy = Spring.GetTeamResources(Spring.GetUnitTeam(unitID),"energy")
	
		if energy < 80 then
			Spring.DestroyUnit(unitID)
		end
		Sleep(1000)
	end
end
