local base = piece "base"
local body = piece "body"
local flare = piece "flare"
-- declares all the pieces we'll use in the script.

local SIG_AIM = 2
local hidden = false

local RESTORE_DELAY = (Spring.UnitScript.GetLongestReloadTime(unitID) * 2)
-- picks a sensible time to wait before trying to turn the turret back to default.

function script.Create()
	StartThread(HideThings) 
	return 0
end

local function RestoreAfterDelay(unitID)
    -- defines a local funtion to wait a bit, then move the turret back to how it was originally.
	Sleep(RESTORE_DELAY)
	Turn(body, y_axis, 0, math.rad(85))
	Turn(body, x_axis, 0, math.rad(85))
end

function script.AimWeapon(weaponID, heading, pitch)
	Signal(SIG_AIM)
	SetSignalMask(SIG_AIM)
    -- each time the Signal is called, all other functions with the same SignalMask will stop running. This makes sure the tank isn't trying to fire at something, and restore the turret position, at the same time.
	--Turn(body, y_axis, heading, math.rad(85))
	--Turn(body, x_axis, pitch, math.rad(85))
	--WaitForTurn(body, y_axis)
	--WaitForTurn(body, x_axis)
	StartThread(RestoreAfterDelay)
	return true
end

function script.FireWeapon(weaponID)
	EmitSfx(flare, 0)
end

function script.QueryWeapon() return flare end
-- The piece that the bullet/laser/whatever comes out of.

function script.AimFromWeapon() return body end
-- The unit looks from this piece down the QueryWeapon piece, to see whether it's aiming at anything.

function script.Killed(recentDamage, maxHealth)
	--local x,y,z = Spring.GetUnitBasePosition(unitID)
	--Spring.SpawnCEG("DEATH_FX",x,y,z,0,0,0,5,0)
	return 0
end

function script.HitByWeapon(x,z,weaponDef,damage)
    -- This stops the unit taking damage until it's been built.
	if GetUnitValue(COB.BUILD_PERCENT_LEFT)>2 then return 0
	else return damage
	end
end

function HideThings()

	env = Spring.UnitScript.GetScriptEnv(unitID)
	env.hidden = false

	while not env.hidden do
		if GetUnitValue(COB.BUILD_PERCENT_LEFT)<3 then return end
		Sleep(100)
	end
	Hide(base)
	Hide(body)
	Hide(flare)
	while GetUnitValue(COB.BUILD_PERCENT_LEFT)>50 do Sleep(100) end
	Spring.GiveOrderToUnit(unitID,CMD.CLOAK,{1},{})
	while GetUnitValue(COB.BUILD_PERCENT_LEFT)>2 do Sleep(100) end
	Show(base)
	Show(body)
	Show(flare)
end
