local unitName  =  "spike_decoy"

local unitDef  =  {
--Internal settings
    BuildPic = "spike_decoy.bmp",
    Category = "TANK SMALL NOTAIR NOTSUB",
    ObjectName = "spike.s3o",
    name = "Spike",
    Side = "TANKS",
    TEDClass = "TANK",
    UnitName = "spike_decoy",
    script = "spikescript_decoy.lua",
    
--Unit limitations and properties
    BuildTime = 10,
    Description = "Decoy.",
    MaxDamage = 30,
    RadarDistance = 0,
    SightDistance = 100,
    SoundCategory = "TANK",
    Upright = 0,
    
--Energy and metal related
    BuildCostEnergy = 0,
    BuildCostMetal = 0,
    
--Pathfinding and related
    Acceleration = 1,
    BrakeRate = 6,
    FootprintX = 2,
    FootprintZ = 2,
    MaxSlope = 15,
    MaxVelocity = 9.0,
    MaxWaterDepth = 20,
    MovementClass = "Default2x2",
    TurnRate = 2500,
    TurnRadius = 700,
    mass = 100,
    
--Abilities
    Builder = 0,
    CanAttack = 1,
    CanFly = 1,
    CruiseAlt = 80,
    AirHoverFactor = 0,
    AirStrafe = true,
    BankingAllowed = true,
    HoverAttack = 1,
    CanGuard = 1,
    CanMove = 1,
    CanPatrol = 1,
    CanStop = 1,
    LeaveTracks = 0,
    Reclaimable = 0,
    CloakCost = 1,
    CloakCostMoving = 1,
    MinCloakDistance = 50,
    
--Hitbox
--    collisionVolumeOffsets    =  "0 0 0",
--    collisionVolumeScales     =  "20 20 20",
--    collisionVolumeTest       =  1,
--    collisionVolumeType       =  "box",
    
--Weapons and related
    BadTargetCategory = "NOTAIR",
    ExplodeAs = "death",
    SelfDestructAs = "death",
    NoChaseCategory = "AIR",

    weapons = {
        [1] = {
            def = "kvkitelaser",
        },
    },
}

local weaponDefs = {
    orangeblob = {
		name = "Orange Plasma Cannon",
		weapontype = "Cannon",
		accuracy = 10,
		areaofeffect = 100,
		avoidfeature = false,
		avoidfriendly = true,
		canattackground = true,
		collidefriendly = true,
		collisionsize = 8,
		commandfire = false,
		craterboost = 0,
		cratermult = 0,
		edgeeffectiveness = 0.1,
		explosionspeed = 128,
		impulseboost = 0,
		impulsefactor = 0,
		intensity = 1,
		noselfdamage = true,
		size = 4,
--        soundstart = "tank_fire",
        soundhit = "orangeblob_explo",
		range = 250,
		reloadtime = 1.5,
		rgbcolor = "1.0 1.0 1.0",
		turret = true,
		texture1 = "flame",
		weaponvelocity = 800,
		explosiongenerator = "custom:TANKGUN_FX",

		burst = 3,
		burstrate = 0.1,

		damage =
		{
			default = 0.00000001,
		},
	},

	kvkitelaser  =  
	{
		weapontype = "BeamLaser",
		areaofeffect = 8,
		avoidfeature = true,
		avoidfriendly = true,
		accuracy = 0,
		movingaccuracy = 0,
		beamtime = 0.05,
		canattackground = true,
		collisionsize = 8,
		commandFire = false,
		corethickness = 0.25,
		craterboost = true,
		cratermult = true,
		explosionspeed = true,
		impulseboost = true,
		impulsefactor = true,
		intensity = 0.75,
		laserflaresize = 7,
		lineofsight = true,
		minintensity = 0.9,
		noselfdamage = true,
		range = 350,
		reloadtime = 0.25,
		rgbcolor = "0.0 1.0 0.0",
		rgbcolor2 = "1 1 1",
		thickness = 2.5,
		turret = true,
 		texture1 = "laserfalloff",
 		texture2 = "laserend",
		explosiongenerator = "custom:LASER_FX",
		weaponvelocity = 400,
		soundstart = "laser",
		damage = 
		{
			default = 0,
		},
	},

	death = 
	{
		name = "death",
		impulsefactor = 0,
		impulseboost = 0,
		cratermult = 0,
		craterboost = 0,
		areaofeffect = 50,
		explosiongenerator = "custom:DEATH_FX",
		avoidfriendly = 0,
		collidefriendly = 1,
		explosionspeed = 5,
		soundHit = "explodeath",
		damage  = 
		{
			default = 0,
		},
	},
}

unitDef.weaponDefs = weaponDefs


unitDef.weaponDefs = weaponDefs
return lowerkeys({ [unitName]  =  unitDef })
